#ifndef NDOSDAQCHANNELMAP_H
#define NDOSDAQCHANNELMAP_H

#include "DAQChannelMap/DAQChannelMap.h"
#include "DAQChannelMap/NDOSDAQChannelMapConstants.h"

namespace daqchannelmap {
  class NDOSDAQChannelMap : public DAQChannelMap
  {
    // NDOS specific functions and mapping. 
  public:
    dchan encodeDChan(lchan logicalchan) const;
    lchan encodeLChan(dchan daqchan)     const;
    
    block_t      computeBlock(lchan logicalchan)        const; 
    plane_t      computePlaneInBlock(lchan logicalchan) const;
    unsigned int computeModule(lchan logicalchan)       const;
    fiber_t      computeFiberInModule(dchan daqchan)    const;
    
    DetView_TYPE getView(dchan daqchan)           const;
    unsigned int getTotalNumberOfDiblocks()       const;
    unsigned int getNumberOfDCM(DiBlock_TYPE dbt) const;
    DiBlock_TYPE getDiBlockType(dchan chan)       const;
    
    NDOSDAQChannelMap();
    virtual ~NDOSDAQChannelMap();
    
  private:
    fiber_t PixelToFiber(pixel_t pixel) const;
    pixel_t FiberToPixel(fiber_t fiber) const; 
      
    bool printBinary(uint32_t) const;
    bool printHex(uint32_t)    const;
  };
}
#endif
////////////////////////////////////////////////////////////////////////
