#include "DAQDataFormats/RawTriggerRangeV0.h"
#include "DAQDataFormats/BitFields.h"
#include <boost/format.hpp>

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawTriggerRange
#define  CURRENT_CLASS_VERSION        0
#define  CURRENT_FIELDS_SUB_NAMESPACE triggerrange
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats{
namespace VERSION_NAMESPACE{

//------------------------Constructors------------------------------------------
RawTriggerRange::RawTriggerRange(const version_t version):
            PREVIOUS_VERSION_CLASS_NAME(version)
           ,ZEROOUT_GET_AND_SET(Version       )
           ,ZEROOUT_GET_AND_SET(TriggerLength)
{}

//------------------------------------------------------------------------------
RawTriggerRange::RawTriggerRange(const RawTriggerRange& copyin):
            PREVIOUS_VERSION_CLASS_NAME(copyin)
           ,DEEPCOPY_GET_AND_SET(Version       )
           ,DEEPCOPY_GET_AND_SET(TriggerLength)
{}

//------------------------------------------------------------------------------
RawTriggerRange::~RawTriggerRange(){}

//------------------------------------------------------------------------------
// General Initialization
void RawTriggerRange::init(){
    EXECUTE_FUNCTION(setVersion)(_version);
}
 
//------------------------------------------------------------------------------
void RawTriggerRange::print(std::ostream& os) const {

    os<<"++++ Trigger Range ++++\n";
    os<<boost::format("Trigger Range Version:\t%u\n")%EXECUTE_FUNCTION(getVersion)();
    os<<boost::format("Trigger range:\t\t%u\n")%EXECUTE_FUNCTION(getTriggerLength)();
    PRINT_ON_DEBUG("Buffer is set to "<<_Buffer)
}

}}// end of namespaces