#include <DatabaseUtils/SimpleParameterSet.h>

namespace dbutils {

std::vector<std::string> SimpleParameterSet::keys() const
{
    std::vector<std::string> resultList;
    std::map<std::string, std::string>::const_iterator iter;
    std::map<std::string, std::string>::const_iterator iterEnd = _paramSet.end();
    for (iter = _paramSet.begin(); iter != iterEnd; ++iter) {
        resultList.push_back(iter->first);
    }
    return resultList;
}

std::string SimpleParameterSet::toString() const
{
    std::string result;
    std::map<std::string, std::string>::const_iterator iter;
    std::map<std::string, std::string>::const_iterator iterEnd = _paramSet.end();
    bool first = true;
    for (iter = _paramSet.begin(); iter != iterEnd; ++iter) {
        if (first) {first = false;}
        else {result.append(";");}
        result.append(iter->first);
        result.append("=");
        result.append(iter->second);
    }
    return result;
}

};  // end of namespace dbutils
